UNIT mTGCircle;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses graphics, mTGeoObj;

type
   TGCircle = CLASS(TGeoObj)

     // weitere Attribute
     protected
         r : Integer;

     // weitere Methoden
     public
        constructor Create(ix,iy,ir:Integer; iCol:TColor);
        procedure DrawIt(target:TCanvas); override;
        procedure HideIt(target:TCanvas); override;
        function Dist(mx, my: Integer): Double; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TGCircle: Methodendefinition 
//+---------------------------------------------------------------------

//-------- Create (public) ---------------------------------------------
constructor TGCircle.Create(ix,iy,ir:Integer; iCol:TColor);
begin
  Inherited create(ix, iy, iCol);
  r := ir;
end;

//-------- DrawIt (public) ---------------------------------------------
procedure TGCircle.DrawIt(target:TCanvas);
begin
  with target do begin
    Pen.Color   := col;
    Brush.Style := bsClear;
    Ellipse(x-r, y-r, x+r, y+r);
    end;
end;

//-------- HideIt (public) ---------------------------------------------
procedure TGCircle.HideIt(target:TCanvas);
begin
  with target do begin
    Pen.Color   := clWhite;
    Brush.Style := bsClear;
    Ellipse(x-r, y-r, x+r, y+r);
    end;
end;

//--------- Dist (public) ------------------------------------------------
function TGCircle.Dist(mx, my: Integer): Double;
  begin
  Result := Abs(Sqrt(Sqr(mx - x) + Sqr(my - y)) - r);
  end;

end.
