UNIT mTGLine;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses graphics, mTGeoObj;

type
   TGLine = CLASS(TGeoObj)

     // weitere Attribute
     protected
         xe : Integer;
         ye : Integer;

     // weitere Methoden
     public
        constructor Create(ix, iy, ixe, iye: Integer; iCol: TColor);
        procedure DrawIt(target: TCanvas); override;
        procedure HideIt(target: TCanvas); override;
        function Dist(mx, my: Integer): Double; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TGLine: Methodendefinition
//+---------------------------------------------------------------------

//-------- Create (public) ---------------------------------------------
constructor TGLine.Create(ix, iy, ixe, iye: Integer; iCol: TColor);
begin
  Inherited create(ix, iy, iCol);
  xe := ixe;
  ye := iye;
end;

//-------- DrawIt (public) ---------------------------------------------
procedure TGLine.DrawIt(target: TCanvas);
begin
  With target do begin
    Pen.Color := col;
    MoveTo(x, y);
    LineTo(xe, ye);
    end;
end;

//-------- HideIt (public) ---------------------------------------------
procedure TGLine.HideIt(target: TCanvas);
begin
  With target do begin
    Pen.Color := clWhite;
    MoveTo(x, y);
    LineTo(xe, ye);
    end;
end;

//--------- Dist (public) ------------------------------------------------
function TGLine.Dist(mx, my: Integer): Double;

  procedure GetSegmentFootPoint (    xq, yq, xr, yr, xm, ym: Double;
                                 var xf, yf                : Double);
    var s, x21, y21, sqd : Double;
    begin
    x21 := xr - xq;
    y21 := yr - yq;
    sqd := Sqr (x21) + Sqr (y21);
    If sqd > 1e-6 then begin
      s   := ((xm - xq) * x21 + (ym - yq) * y21) / sqd;
      If s > 1 then s := 1;
      If s < 0 then s := 0;
      xf  := xq + s*x21;
      yf  := yq + s*y21;
      end
    else begin
      xf := xq;
      yf := yq;
      end;
    end;

  var fx, fy : Double;
  begin
  GetSegmentFootPoint(x, y, xe, ye, mx, my, fx, fy);
  Result := Sqrt(Sqr(mx - fx) + Sqr(my - fy));
  end;

end.
