UNIT mTGPoint;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses graphics, mTGeoObj;

type
   TGPoint = CLASS(TGeoObj)

     // weitere Methoden
     public
        procedure DrawIt(target:TCanvas); override;
        procedure HideIt(target:TCanvas); override;
        function Dist(mx, my: Integer): Double; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TGPoint: Methodendefinition 
//+---------------------------------------------------------------------

//-------- DrawIt (public) ---------------------------------------------
procedure TGPoint.DrawIt(target:TCanvas);
begin
  With target do begin
    Pen.Color   := col;
    Brush.Color := col;
    Brush.Style := bsSolid;
    Ellipse(x-3, y-3, x+3, y+3);
    end;
end;

//-------- HideIt (public) ---------------------------------------------
procedure TGPoint.HideIt(target:TCanvas);
begin
  With target do begin
    Pen.Color   := clWhite;
    Brush.Color := clWhite;
    Brush.Style := bsSolid;
    Ellipse(x-3, y-3, x+3, y+3);
    end;
end;

//--------- Dist (public) ------------------------------------------------
function TGPoint.Dist(mx, my: Integer): Double;
  begin
  Result := Sqrt(Sqr(mx - x) + Sqr(my - y));
  end;

end.
